Index: src/Actions/ParserAction/SaveXyzAction.cpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ParserAction/SaveXyzAction.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,90 @@
+/*
+ * SaveXyzAction.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include "Actions/ParserAction/SaveXyzAction.hpp"
+#include "Parser/XyzParser.hpp"
+
+#include <iostream>
+#include <string>
+
+using namespace std;
+
+#include "UIElements/UIFactory.hpp"
+#include "UIElements/Dialog.hpp"
+
+#include "atom.hpp"
+#include "molecule.hpp"
+
+/****** ParserSaveXyzAction *****/
+
+//// memento to remember the state when undoing
+//
+//class ParserSaveXyzState : public ActionState {
+//public:
+//  ParserSaveXyzState(molecule* _mol,std::string _lastName) :
+//    mol(_mol),
+//    lastName(_lastName)
+//  {}
+//  molecule* mol;
+//  std::string lastName;
+//};
+
+const char ParserSaveXyzAction::NAME[] = "SaveXyz";
+
+ParserSaveXyzAction::ParserSaveXyzAction() :
+  Action(NAME)
+{}
+
+ParserSaveXyzAction::~ParserSaveXyzAction()
+{}
+
+Action::state_ptr ParserSaveXyzAction::performCall() {
+  string filename;
+  XyzParser parser;
+  Dialog *dialog = UIFactory::getInstance().makeDialog();
+
+  dialog->queryString("filename",&filename, "Filename of the xyz file");
+
+  if(dialog->display()) {
+    // store xyz file
+    ofstream output;
+    output.open(filename.c_str());
+    if (!output.fail())
+      parser.save(&output);
+    output.close();
+  }
+  delete dialog;
+  return Action::failure;
+}
+
+Action::state_ptr ParserSaveXyzAction::performUndo(Action::state_ptr _state) {
+//  ParserSaveXyzState *state = assert_cast<ParserSaveXyzState*>(_state.get());
+
+  return Action::failure;
+//  string newName = state->mol->getName();
+//  state->mol->setName(state->lastName);
+//
+//  return Action::state_ptr(new ParserSaveXyzState(state->mol,newName));
+}
+
+Action::state_ptr ParserSaveXyzAction::performRedo(Action::state_ptr _state){
+  return Action::failure;
+//  // Undo and redo have to do the same for this action
+//  return performUndo(_state);
+}
+
+bool ParserSaveXyzAction::canUndo() {
+  return false;
+}
+
+bool ParserSaveXyzAction::shouldUndo() {
+  return false;
+}
+
+const string ParserSaveXyzAction::getName() {
+  return NAME;
+}
Index: src/Actions/ParserAction/SaveXyzAction.hpp
===================================================================
--- src/Actions/ParserAction/SaveXyzAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Actions/ParserAction/SaveXyzAction.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,31 @@
+/*
+ * SaveXyzAction.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef SAVEXYZACTION_HPP_
+#define SAVEXYZACTION_HPP_
+
+#include "Actions/Action.hpp"
+#include "Actions/Process.hpp"
+
+class ParserSaveXyzAction : public Action {
+public:
+  ParserSaveXyzAction();
+  virtual ~ParserSaveXyzAction();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+private:
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#endif /* SAVEXYZACTION_HPP_ */
Index: src/Actions/Process.cpp
===================================================================
--- src/Actions/Process.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/Process.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -13,7 +13,7 @@
   Action(_name,_doRegister),
   maxSteps(_maxSteps),
+  active(false),
   starts(false),
-  stops(false),
-  active(false)
+  stops(false)
 {}
 
@@ -25,5 +25,5 @@
 
 
-bool Process::isActive(){
+bool Process::isRunning(){
   return active;
 }
@@ -38,5 +38,10 @@
 
 int Process::getCurrStep(){
+  OBSERVE;
   return currStep;
+}
+
+void Process::setCurrStep(int _currStep){
+  currStep = _currStep;
 }
 
@@ -47,8 +52,12 @@
     return 0;
 }
+
 int Process::getMaxSteps(){
   return maxSteps;
 }
 
+void Process::setMaxSteps(int _maxSteps){
+  maxSteps = _maxSteps;
+}
 
 void Process::start(){
@@ -64,19 +73,21 @@
   {
     OBSERVE;
-    active = true;
     currStep=0;
   }
   starts = false;
+  active = true;
 }
+
 void Process::step(){
   OBSERVE;
   currStep++;
 }
+
 void Process::stop(){
+  active=false;
   stops = true;
   {
     OBSERVE;
     currStep=0;
-    active=false;
   }
   {
Index: src/Actions/Process.hpp
===================================================================
--- src/Actions/Process.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Actions/Process.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,4 +19,22 @@
 #include "Actions/Action.hpp"
 
+/**
+ * A Process is an Action that might take some time and therefore has special
+ * methods to allow communication with progress indicators. Indicators
+ * can sign on at a global place and will be notified when any process is doing
+ * a calculation.
+ *
+ * A Process has four states:
+ *  - starting: It is in the process of setting itself up, and wants everybody to know that it will start
+ *              the calculation soon. Indicators should set up anything they need for displaying the progress
+ *              when they are notified by a process in this state.
+ *  - active:   The process is currently doing it's thing and wants any indicator to know it's status, i.e.
+ *              the percentage done.
+ *  - stopping: The process has fullfilled it's purpose and is shutting down. Indicators recieving this status
+ *              should also use it to shut down their indication mechanism and delete any objects allocated for
+ *              this Process
+ *  - inactive: This Process is currently sleeping. If a Process is sending out any signals in this state, there
+ *              is something seriously wrong.
+ */
 class Process : public Action, public Observable
 {
@@ -25,10 +43,12 @@
   virtual ~Process();
 
-  bool  isActive();
+  bool  isRunning();
   bool  doesStart();
   bool  doesStop();
   int   getCurrStep();
+  void  setCurrStep(int _currStep);
   float getDoneRatio();
   int   getMaxSteps();
+  void  setMaxSteps(int _maxSteps);
 
 protected:
Index: src/CommandLineParser.cpp
===================================================================
--- src/CommandLineParser.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/CommandLineParser.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,79 @@
+/*
+ * CommandLineParser.cpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#include <boost/program_options.hpp>
+#include <fstream>
+#include <iostream>
+
+#include "Patterns/Singleton_impl.hpp"
+#include "CommandLineParser.hpp"
+
+using namespace std;
+
+/** Constructor of class CommandLineParser.
+ *
+ */
+CommandLineParser::CommandLineParser() :
+  generic("Generic options"),
+  config("Configuration"),
+  hidden("Hidden options"),
+  visible("Allowed options")
+{}
+
+/** Destructor of class CommandLineParser.
+ *
+ */
+CommandLineParser::~CommandLineParser()
+{}
+
+/** Parses the command line arguments.
+ * Calls program_options::store() and program_options::notify()
+ */
+void CommandLineParser::Parse()
+{
+  po::store(po::command_line_parser(argc,argv).options(cmdline_options).run(), vm);
+  po::store(po::command_line_parser(argc,argv).options(visible).run(), vm);
+  ifstream input;
+  input.open("example.cfg");
+  if (!input.fail())
+    po::store(po::parse_config_file(input, config_file_options), vm);
+  input.close();
+  po::notify(vm);
+}
+
+/** States whether there are command line arguments.
+ * \return true - there are none, false - there is at least one command line argument
+ */
+bool CommandLineParser::isEmpty()
+{
+  return vm.empty();
+}
+
+/** Sets the options.
+ * \param _argc arg count from main()
+ * \param **_argv argument array from main()
+ */
+void CommandLineParser::setOptions(int _argc, char **_argv)
+{
+  argc = _argc;
+  argv = _argv;
+  cmdline_options.add(generic).add(config).add(hidden);
+  config_file_options.add(config).add(hidden);
+  visible.add(generic).add(config);
+}
+
+/** Makes the Parser parse the command line options with current known options.
+ * \param _argc arg count from main()
+ * \param **_argv argument array from main()
+ */
+void CommandLineParser::Run(int _argc, char **_argv)
+{
+  setOptions(_argc,_argv);
+  Parse();
+}
+
+CONSTRUCT_SINGLETON(CommandLineParser)
Index: src/CommandLineParser.hpp
===================================================================
--- src/CommandLineParser.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/CommandLineParser.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,63 @@
+/*
+ * CommandLineParser.hpp
+ *
+ *  Created on: May 8, 2010
+ *      Author: heber
+ */
+
+#ifndef COMMANDLINEPARSER_HPP_
+#define COMMANDLINEPARSER_HPP_
+
+#include <boost/program_options.hpp>
+
+namespace po = boost::program_options;
+
+#include "Patterns/Singleton.hpp"
+
+
+class CommandLineParser : public Singleton<CommandLineParser> {
+  friend class Singleton<CommandLineParser>;
+public:
+
+  // Parses the command line arguments in CommandLineParser::**argv with currently known options.
+  void Run(int _argc, char **_argv);
+
+  // Checks whether there have been any commands on the command line.
+  bool isEmpty();
+
+  /* boost's program_options are sorted into three categories:
+   * -# generic options: option available to both command line and config
+   * -# config options: only available in the config file
+   * -# hidden options: options which the user is not shown on "help"
+   */
+  po::options_description generic;
+  po::options_description config;
+  po::options_description hidden;
+
+  po::options_description visible;
+
+  po::variables_map vm;
+
+private:
+  // private constructor and destructor
+  CommandLineParser();
+  virtual ~CommandLineParser();
+
+  /* The following program_options options_decriptions are used to
+   * generate the various cases and call differently in Parse().
+   */
+  po::options_description cmdline_options;
+  po::options_description config_file_options;
+
+  // Sets the options from the three cases.
+  void setOptions(int _argc, char **_argv);
+
+  // Parses all options from command line and config file
+  void Parse();
+
+  // argument counter and array passed on from main()
+  int argc;
+  char **argv;
+};
+
+#endif /* COMMANDLINEPARSER_HPP_ */
Index: src/Descriptors/AtomDescriptor.cpp
===================================================================
--- src/Descriptors/AtomDescriptor.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -19,6 +19,5 @@
 using namespace std;
 
-typedef map<int,atom*> atoms_t;
-typedef atoms_t::iterator atoms_iter_t;
+typedef World::AtomSet::iterator atoms_iter_t;
 
 /************************ Forwarding object **************************************/
@@ -68,10 +67,10 @@
 }
 
-atoms_t& AtomDescriptor_impl::getAtoms(){
-  return World::get()->atoms;
+World::AtomSet& AtomDescriptor_impl::getAtoms(){
+  return World::getInstance().atoms;
 }
 
 atom* AtomDescriptor_impl::find() {
-  atoms_t atoms = getAtoms();
+  World::AtomSet atoms = getAtoms();
   atoms_iter_t res = find_if(atoms.begin(),atoms.end(),boost::bind(&AtomDescriptor_impl::predicate,this,_1));
   return (res!=atoms.end())?((*res).second):0;
@@ -80,5 +79,5 @@
 vector<atom*> AtomDescriptor_impl::findAll() {
   vector<atom*> res;
-  atoms_t atoms = getAtoms();
+  World::AtomSet atoms = getAtoms();
   atoms_iter_t iter;
   for(iter=atoms.begin();iter!=atoms.end();++iter) {
@@ -98,5 +97,5 @@
 {}
 
-bool AtomAllDescriptor_impl::predicate(std::pair<int,atom*>){
+bool AtomAllDescriptor_impl::predicate(std::pair<atomId_t,atom*>){
   return true;
 }
@@ -112,5 +111,5 @@
 {}
 
-bool AtomNoneDescriptor_impl::predicate(std::pair<int,atom*>){
+bool AtomNoneDescriptor_impl::predicate(std::pair<atomId_t,atom*>){
   return false;
 }
@@ -130,5 +129,5 @@
 {}
 
-bool AtomAndDescriptor_impl::predicate(std::pair<int,atom*> atom){
+bool AtomAndDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom){
   return lhs->predicate(atom) && rhs->predicate(atom);
 }
@@ -146,5 +145,5 @@
 }
 
-bool AtomOrDescriptor_impl::predicate(std::pair<int,atom*> atom){
+bool AtomOrDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom){
   return lhs->predicate(atom) || rhs->predicate(atom);
 }
@@ -166,5 +165,5 @@
 }
 
-bool AtomNotDescriptor_impl::predicate(std::pair<int,atom*> atom){
+bool AtomNotDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom){
  return !(arg->predicate(atom));
 }
Index: src/Descriptors/AtomDescriptor.hpp
===================================================================
--- src/Descriptors/AtomDescriptor.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -15,4 +15,5 @@
 #include "World.hpp"
 
+class World;
 class atom;
 
@@ -20,7 +21,20 @@
 class AtomDescripter_impl;
 
+/**
+ * An AtomDescriptor describes a Set of Atoms from the World. Can be used for any method that needs to work on
+ * a specific set of Atoms.
+ *
+ * This Class is implemented using the PIMPL-Idion, i.e. this class only contains an abstract structure
+ * that forwards any request to a wrapped pointer-to-implementation. This way operators and calculations
+ * on Descriptors are possible.
+ *
+ * Concrete Implementation Objects can be shared between multiple Wrappers, so make sure that
+ * any Implementation remainst constant during lifetime.
+ */
 class AtomDescriptor {
+  // close coupling to the world to allow access
   friend atom* World::getAtom(AtomDescriptor descriptor);
   friend std::vector<atom*> World::getAllAtoms(AtomDescriptor descriptor);
+  template <class,class,class> friend class SelectiveIterator;
 
   friend AtomDescriptor operator&&(const AtomDescriptor &lhs, const AtomDescriptor &rhs);
@@ -29,15 +43,38 @@
 
 public:
-  typedef boost::shared_ptr<AtomDescriptor_impl> impl_ptr;
+  typedef boost::shared_ptr<AtomDescriptor_impl> impl_ptr; //!< Allow easy changes of the pointer-to-implementation type
 
   AtomDescriptor(impl_ptr);
+
+  /**
+   * Copy constructor.
+   * Takes the Implementation from the copied object and sets it's own pointer to link there.
+   * This way the actuall implementation object is shared between copy and original
+   */
   AtomDescriptor(const AtomDescriptor&);
   ~AtomDescriptor();
 
+  /**
+   * Assignment Operator.
+   *
+   * Implemented by setting the pointer to the new Implementation.
+   */
   AtomDescriptor &operator=(AtomDescriptor &);
 
 protected:
+  /**
+   * forward Method to implementation
+   */
   atom* find();
+
+  /**
+   * forward Method to implementation
+   */
   std::vector<atom*> findAll();
+
+  /**
+   * Return the implementation this Wrapper currently points to.
+   * Used for copying, assignment and in Iterators over subsets of the World.
+   */
   impl_ptr get_impl() const;
 
@@ -46,11 +83,31 @@
 };
 
-// Functions to construct actual descriptors
+/**
+ * produce an Atomdescriptor that at the point of construction contains an implementation that matches all Atoms
+ */
 AtomDescriptor AllAtoms();
+
+/**
+ * produce an Atomdescriptor that at the point of construction contains an implementation that matches no Atoms
+ */
 AtomDescriptor NoAtoms();
 
-// no true short circuit, but the test of the second descriptor wont be done
+/**
+ * Set Intersection for two Atomdescriptors. The resulting Atomdescriptor will only match an Atom if both
+ * given Atomdescriptors also match. Uses short circuit inside, so the second predicate wont be called
+ * when the first one failed.
+ */
 AtomDescriptor operator&&(const AtomDescriptor &lhs, const AtomDescriptor &rhs);
+
+/**
+ * Set Union for two AtomDescriptors. The resulting AtomDescriptor will match an Atom if at least one of
+ * the two given AtomDescriptors does match. Used short circuit inside, so the second predicate wont
+ * be called when the first one failed.
+ */
 AtomDescriptor operator||(const AtomDescriptor &lhs, const AtomDescriptor &rhs);
+
+/**
+ * Set inversion for an AtomDescriptor. Matches an Atom if the given AtomDescriptor did not match.
+ */
 AtomDescriptor operator!(const AtomDescriptor &arg);
 
Index: src/Descriptors/AtomDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomDescriptor_impl.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -1,5 +1,15 @@
+#ifndef ATOMDESCRIPTOR_IMPL_HPP
+#define ATOMDESCRIPTOR_IMPL_HPP
+
 #include "Descriptors/AtomDescriptor.hpp"
 
 /************************ Declarations of implementation Objects ************************/
+
+/**
+ * This class implements a general Base class for AtomDescriptors using the PIMPL-Idiom
+ *
+ * The predicate for this class is empty and should be implemented by derived classes.
+ * By the predicate it is described which atoms should be picked for a given descriptor.
+ */
 
 class AtomDescriptor_impl
@@ -11,30 +21,71 @@
   virtual ~AtomDescriptor_impl();
 
-  virtual bool predicate(std::pair<int,atom*>)=0;
+  /**
+   * Implement this abstract Method to make a concrete AtomDescriptor pick certain Atoms
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>)=0;
 
 protected:
+
+  /**
+   * This method is called when the Descriptor is used to find the first matching
+   * Atom. Walks through all Atoms and stops on the first match. Can be implemented
+   * when the searched Atom can be found in a more efficient way. Calculated
+   * Atomdescriptors will always use this method, so no improvement there.
+   */
   virtual atom* find();
+
+  /**
+   * This method is called when the Descriptor is used to find all matching Atoms.
+   * Walks through all Atoms and tests the predicate on each one. A vector of all
+   * matching Atoms is returned.
+   */
   virtual std::vector<atom*> findAll();
-  std::map<int,atom*>& getAtoms();
+
+  /**
+   * This method is used internally to query the Set of Atoms from the world.
+   * By using this method derived classes can also access the Internal World Datastructre.
+   * Implemented in full in the Base Descriptor Implementation, so only this one method
+   * needs to be friend with the World class.
+   */
+  World::AtomSet& getAtoms();
 };
 
 /************************** Universe and Emptyset *****************/
 
+/**
+ * A simple AtomDescriptor that will always match all Atoms present in the World.
+ */
 class AtomAllDescriptor_impl : public AtomDescriptor_impl {
 public:
   AtomAllDescriptor_impl();
   virtual ~AtomAllDescriptor_impl();
-  virtual bool predicate(std::pair<int,atom*>);
+
+  /**
+   * Always returns true for any Atom
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>);
 };
 
+
+/**
+ * An AtomDescriptor that never matches any Atom in the World.
+ */
 class AtomNoneDescriptor_impl : public AtomDescriptor_impl {
 public:
   AtomNoneDescriptor_impl();
   virtual ~AtomNoneDescriptor_impl();
-  virtual bool predicate(std::pair<int,atom*>);
+
+  /**
+   * Always returns false for any Atom
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>);
 };
 
 /************************** Operator stuff ************************/
 
+/**
+ * Intersection of two AtomDescriptors
+ */
 class AtomAndDescriptor_impl : public AtomDescriptor_impl
 {
@@ -42,5 +93,10 @@
   AtomAndDescriptor_impl(AtomDescriptor::impl_ptr _lhs, AtomDescriptor::impl_ptr _rhs);
   ~AtomAndDescriptor_impl();
-  virtual bool predicate(std::pair<int,atom*>);
+
+  /**
+   * This predicate uses the predicate from the first && the predicate from the
+   * second Descriptor to decide if an Atom should be selected.
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>);
 
 private:
@@ -49,4 +105,7 @@
 };
 
+/**
+ * Union of two AtomDescriptors
+ */
 class AtomOrDescriptor_impl : public AtomDescriptor_impl
 {
@@ -54,5 +113,10 @@
   AtomOrDescriptor_impl(AtomDescriptor::impl_ptr _lhs, AtomDescriptor::impl_ptr _rhs);
   virtual ~AtomOrDescriptor_impl();
-  virtual bool predicate(std::pair<int,atom*>);
+
+  /**
+   * This predicate uses the predicate form the first || the predicate from the
+   * second Descriptor to decide if an Atom should be selected.
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>);
 
 private:
@@ -61,4 +125,7 @@
 };
 
+/**
+ * Set Inversion of a Descriptor
+ */
 class AtomNotDescriptor_impl : public AtomDescriptor_impl
 {
@@ -67,7 +134,12 @@
   virtual ~AtomNotDescriptor_impl();
 
-  virtual bool predicate(std::pair<int,atom*>);
+  /**
+   * Opposite of the given descriptor predicate.
+   */
+  virtual bool predicate(std::pair<atomId_t,atom*>);
 
 private:
   AtomDescriptor::impl_ptr arg;
 };
+
+#endif //ATOMDESCRIPTOR_IMPL_HPP
Index: src/Descriptors/AtomIdDescriptor.cpp
===================================================================
--- src/Descriptors/AtomIdDescriptor.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomIdDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -14,5 +14,5 @@
 
 
-AtomIdDescriptor_impl::AtomIdDescriptor_impl(int _id) :
+AtomIdDescriptor_impl::AtomIdDescriptor_impl(atomId_t _id) :
   id(_id)
 {}
@@ -21,27 +21,20 @@
 {}
 
-bool AtomIdDescriptor_impl::predicate(std::pair<int,atom*> atom) {
-  return atom.second->getId()==id;
+bool AtomIdDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom) {
+  return atom.first==id;
 }
 
-AtomDescriptor AtomById(int id){
+AtomDescriptor AtomById(atomId_t id){
   return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomIdDescriptor_impl(id)));
 }
 
-#if 0
-
-// so far the lookuptable for Atoms-by-id does not work, since atoms don't get an ID upon creation.
-// instead of this we rely on walking through all atoms.
-
-atom *AtomIdDescriptor::find(){
-  map<int,atom*> atoms = getAtoms();
-  map<int,atom*>::iterator res = atoms.find(id);
+atom *AtomIdDescriptor_impl::find(){
+  World::AtomSet atoms = getAtoms();
+  World::AtomSet::iterator res = atoms.find(id);
   return (res!=atoms.end())?((*res).second):0;
 }
 
-vector<atom*> AtomIdDescriptor::findAll(){
+vector<atom*> AtomIdDescriptor_impl::findAll(){
   atom *res = find();
   return (res)?(vector<atom*>(1,res)):(vector<atom*>());
 }
-
-#endif
Index: src/Descriptors/AtomIdDescriptor.hpp
===================================================================
--- src/Descriptors/AtomIdDescriptor.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomIdDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,7 +9,8 @@
 #define ATOMIDDESCRIPTOR_HPP_
 
+#include "defs.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 
-AtomDescriptor AtomById(int id);
+AtomDescriptor AtomById(atomId_t id);
 
 #endif /* ATOMIDDESCRIPTOR_HPP_ */
Index: src/Descriptors/AtomIdDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomIdDescriptor_impl.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/Descriptors/AtomIdDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -1,3 +1,5 @@
-#include "Descriptors/AtomIdDescriptor.hpp"
+#ifndef ATOMIDDESCRIPTOR_IMPL_HPP
+#define ATOMIDDESCRIPTOR_IMPL_HPP
+
 #include "Descriptors/AtomDescriptor_impl.hpp"
 
@@ -5,15 +7,15 @@
 {
 public:
-  AtomIdDescriptor_impl(int _id);
+  AtomIdDescriptor_impl(atomId_t _id);
   virtual ~AtomIdDescriptor_impl();
 
-  bool predicate(std::pair<int,atom*> atom);
+  bool predicate(std::pair<atomId_t,atom*> atom);
 
 protected:
-#if 0
-  atom *find();
-  std::vector<atom*> findAll();
-#endif
+  virtual atom *find();
+  virtual std::vector<atom*> findAll();
 private:
-  int id;
+  atomId_t id;
 };
+
+#endif //ATOMIDDESCRIPTOR_IMPL_HPP
Index: src/Descriptors/AtomTypeDescriptor.cpp
===================================================================
--- src/Descriptors/AtomTypeDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/AtomTypeDescriptor.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,33 @@
+/*
+ * AtomTypeDescriptor_impl.cpp
+ *
+ *  Created on: Feb 25, 2010
+ *      Author: crueger
+ */
+
+#include "Descriptors/AtomTypeDescriptor.hpp"
+#include "Descriptors/AtomTypeDescriptor_impl.hpp"
+
+#include "atom.hpp"
+#include "World.hpp"
+#include "periodentafel.hpp"
+
+AtomTypeDescriptor_impl::AtomTypeDescriptor_impl(const element* _type) :
+  type(_type)
+{}
+
+AtomTypeDescriptor_impl::~AtomTypeDescriptor_impl()
+{}
+
+bool AtomTypeDescriptor_impl::predicate(std::pair<atomId_t,atom*> atom) {
+  return (atom.second->getType()==type);
+}
+
+AtomDescriptor AtomByType(const element *elem){
+  return AtomDescriptor(AtomDescriptor::impl_ptr(new AtomTypeDescriptor_impl(elem)));
+}
+
+AtomDescriptor AtomByType(int Z){
+  const element * elem = World::getInstance().getPeriode()->FindElement(Z);
+  return AtomByType(elem);
+}
Index: src/Descriptors/AtomTypeDescriptor.hpp
===================================================================
--- src/Descriptors/AtomTypeDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/AtomTypeDescriptor.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,18 @@
+/*
+ * AtomTypeDescriptor.h
+ *
+ *  Created on: Feb 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMTYPEDESCRIPTOR_HPP
+#define ATOMTYPEDESCRIPTOR_HPP
+
+#include "Descriptors/AtomDescriptor.hpp"
+
+class element;
+
+AtomDescriptor AtomByType(const element *);
+AtomDescriptor AtomByType(int);
+
+#endif /* ATOMTYPEDESCRIPTOR_HPP */
Index: src/Descriptors/AtomTypeDescriptor_impl.hpp
===================================================================
--- src/Descriptors/AtomTypeDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/AtomTypeDescriptor_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,24 @@
+/*
+ * AtomTypeDescriptor_impl.hpp
+ *
+ *  Created on: Feb 25, 2010
+ *      Author: crueger
+ */
+
+#ifndef ATOMTYPEDESCRIPTOR_IMPL_HPP_
+#define ATOMTYPEDESCRIPTOR_IMPL_HPP_
+
+#include "Descriptors/AtomDescriptor_impl.hpp"
+
+class AtomTypeDescriptor_impl : public AtomDescriptor_impl
+{
+public:
+  AtomTypeDescriptor_impl(const element* _type);
+  virtual ~AtomTypeDescriptor_impl();
+
+  bool predicate(std::pair<atomId_t,atom*> atom);
+private:
+  const element * const type;
+};
+
+#endif /* ATOMTYPEDESCRIPTOR_IMPL_HPP_ */
Index: src/Descriptors/DescriptorBase.hpp
===================================================================
--- src/Descriptors/DescriptorBase.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/DescriptorBase.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,101 @@
+/*
+ * DescriptorBase.hpp
+ *
+ *  Created on: Mar 12, 2010
+ *      Author: crueger
+ */
+
+#ifndef DESCRIPTORBASE_HPP_
+#define DESCRIPTORBASE_HPP_
+
+#include <vector>
+#include <boost/shared_ptr.hpp>
+
+/***
+ * Code in this file is not used.
+ *
+ * I was not able to figure out how to factor out the common code for
+ * descriptors and have given up :-( . If somebody else wants to have
+ * another shot just go ahead, but expect a hard ride from here on.
+ */
+
+template<class _Target,
+         class _Container>
+class DescriptorBase_impl;
+
+
+template<class _Target,
+         class _Container>
+class SelectiveIterator;
+
+template<class _Target,
+         class _Container>
+class DescriptorBase
+{
+  friend class DescriptorBase_impl<_Target,_Container>;
+  friend class SelectiveIterator<_Target,_Container>;
+
+
+  // expose the type of this descriptor to the public
+public:
+  typedef _Target     Target;
+  typedef std::vector<Target> TargetVec;
+
+protected:
+  typedef _Container  Container;
+  typedef typename Container::iterator iterator;
+
+  typedef DescriptorBase_impl<Target,Container>  impl;
+  typedef boost::shared_ptr<impl> impl_ptr;
+
+
+public:
+
+  DescriptorBase();
+  DescriptorBase(const DescriptorBase&);
+  DescriptorBase(impl_ptr);
+  virtual ~DescriptorBase();
+
+  DescriptorBase& operator=(const DescriptorBase&);
+
+  /**
+   * forward Method to implementation
+   */
+  Target find(Container&);
+
+  /**
+   * forward Method to implementation
+   */
+  TargetVec findAll(Container&);
+
+
+private:
+  impl_ptr theImpl;
+};
+
+template<class _Target,
+         class _Container>
+DescriptorBase<_Target,_Container> AllX();
+
+template<class _Target,
+         class _Container>
+DescriptorBase<_Target,_Container> NoX();
+
+template<class _Target,
+         class _Container>
+DescriptorBase<_Target,_Container>
+  operator&&(DescriptorBase<_Target,_Container>&,
+             DescriptorBase<_Target,_Container>&);
+
+template<class _Target,
+         class _Container>
+DescriptorBase<_Target,_Container>
+  operator||(DescriptorBase<_Target,_Container>&,
+             DescriptorBase<_Target,_Container>&);
+
+template<class _Target,
+         class _Container>
+DescriptorBase<_Target,_Container>
+  operator!(DescriptorBase<_Target,_Container>&);
+
+#endif /* DESCRIPTORBASE_HPP_ */
Index: src/Descriptors/DescriptorBase_impl.hpp
===================================================================
--- src/Descriptors/DescriptorBase_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
+++ src/Descriptors/DescriptorBase_impl.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -0,0 +1,68 @@
+/*
+ * DescriptorBase_impl.hpp
+ *
+ *  Created on: Mar 12, 2010
+ *      Author: crueger
+ */
+
+#ifndef DESCRIPTORBASE_IMPL_HPP_
+#define DESCRIPTORBASE_IMPL_HPP_
+
+#include "Descriptors/DescriptorBase.hpp"
+#include <utility>
+#include <boost/bind.hpp>
+
+template<class _Target,
+         class _Container>
+class DescriptorBase_impl{
+public:
+  typedef _Target Target;
+  typedef std::vector<Target> TargetVec;
+  typedef _Container Container;
+  typedef typename Container::value_type value_type;
+  typedef typename Container::iterator iterator;
+
+  DescriptorBase_impl();
+  ~DescriptorBase_impl();
+
+  virtual bool predicate(value_type)=0;
+
+  virtual Target    find(Container&);
+  virtual TargetVec findAll(Container&);
+protected:
+  const _take<Target,value_type> take;
+};
+
+template<class _Target,
+         class _Container>
+DescriptorBase_impl<_Target,_Container>::DescriptorBase_impl(){}
+
+template<class _Target,
+         class _Container>
+DescriptorBase_impl<_Target,_Container>::~DescriptorBase_impl(){}
+
+template<class _Target,
+         class _Container>
+typename DescriptorBase_impl<_Target,_Container>::Target
+  DescriptorBase_impl<_Target,_Container>::find(DescriptorBase_impl<_Target,_Container>::Container& container){
+    iterator res = find_if(container.begin(),
+                           container.end(),
+                           boost::bind(&DescriptorBase_impl<_Target,_Container>::predicate,this,_1));
+    return (res!=container.end())?(take(*res)):0;
+  }
+
+template<class _Target,
+         class _Container>
+typename DescriptorBase_impl<_Target,_Container>::TargetVec
+  DescriptorBase_impl<_Target,_Container>::findAll(DescriptorBase_impl<_Target,_Container>::Container& container) {
+  TargetVec res;
+  iterator iter;
+  for(iter=container.begin();iter!=container.end();++iter) {
+    if(predicate(*iter)){
+      res.push_back(take(*iter));
+    }
+  }
+  return res;
+}
+
+#endif /* DESCRIPTORBASE_IMPL_HPP_ */
